#include <Windows.h>
#include <stdio.h>
#include <stdlib.h>

void PrintErrorMessage(char *szFile, char *szFunction, int nLine) {
	LPVOID lpMsgBuf;
	DWORD dwError = 0;

	FormatMessage(
	    FORMAT_MESSAGE_ALLOCATE_BUFFER |
	    FORMAT_MESSAGE_FROM_SYSTEM |
	    FORMAT_MESSAGE_IGNORE_INSERTS,
	    NULL,
	    (dwError = GetLastError()),
	    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // ̌
	    (LPTSTR) &lpMsgBuf,
	    0,
	    NULL
	);

	printf("%s:%d: %s(%d): %s\n", szFile, nLine, szFunction, dwError, lpMsgBuf);
	LocalFree(lpMsgBuf);
}
